<?php
/*
//(C) OXID-Design 2017
//
// The source contained in this file is the property of the OXID-Design
// (Leipziger Allee 36, 76139 Karlsruhe, Germany, www.oxid-design.com).
//
// GNU GENERAL PUBLIC LICENSE
//
//This program is free software;
//you can redistribute it and/or modify it under the terms of the GNU General Public License as published by the Free Software Foundation;
//either version 3 of the License, or (at your option) any later version.
//
//This program is distributed in the hope that it will be useful, but WITHOUT ANY WARRANTY;
//without even the implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU General Public License for more details.
// You should have received a copy of the GNU General Public License along with this program; if not, see <http://www.gnu.org/licenses/>
*/

class od_news_coupon_set extends od_news_coupon_set_parent
{
    public static function addSQLfNotExists($sTableName, $sColumnName)
    {
        if (oxDb::getDb()->Execute("SHOW COLUMNS FROM {$sTableName} LIKE '{$sColumnName}'")->EOF) {
            return true;
        }
        return false;
    }

    public static function addNewsCoupon()
    {
        oxDb::getDb()->execute("ALTER TABLE `oxvoucherseries` ADD COLUMN `ODNEWSCOUPON` TINYINT(1) NOT NULL DEFAULT 0 COMMENT 'Customers can use the same coupon code several times';");
    }

    public static function rmNewsCoupon()
    {
        $sSql = "ALTER TABLE `oxvoucherseries` DROP `ODNEWSCOUPON`;";

        oxDb::getDb()->execute($sSql);
    }

    public static function onActivate()
    {
        if (self::addSQLfNotExists('oxvoucherseries', 'ODNEWSCOUPON')) {
            self::addNewsCoupon();
        }
    }

    public static function onDeactivate()
    {
        //self::rmNewsCoupon();
    }
}
