<?php

/*
//(C) OXID-Design 2017
//
// The source contained in this file is the property of the OXID-Design
// (Leipziger Allee 36, 76139 Karlsruhe, Germany, www.oxid-design.com).
//
// GNU GENERAL PUBLIC LICENSE
//
//This program is free software;
//you can redistribute it and/or modify it under the terms of the GNU General Public License as published by the Free Software Foundation;
//either version 3 of the License, or (at your option) any later version.
//
//This program is distributed in the hope that it will be useful, but WITHOUT ANY WARRANTY;
//without even the implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU General Public License for more details.
// You should have received a copy of the GNU General Public License along with this program; if not, see <http://www.gnu.org/licenses/>
*/

class od_news_coupon extends od_news_coupon_parent
{
    public function getVoucherByNr($sVoucherNr, $aVouchers = array(), $blCheckavalability = false)
    {
        $oRet = null;
        if (!is_null($sVoucherNr)) {
            $sViewName = $this->getViewName();
            $sSeriesViewName = getViewName('oxvoucherseries');
            $oDb = oxDb::getDb();
            $sQ = "select {$sViewName}.* from {$sViewName}, {$sSeriesViewName} where {$sSeriesViewName}.oxid = {$sViewName}.oxvoucherserieid and {$sViewName}.oxvouchernr = " . $oDb->quote($sVoucherNr) . " and ";
            if (is_array($aVouchers)) {
                foreach ($aVouchers as $sVoucherId => $sSkipVoucherNr) {
                    $sQ .= "{$sViewName}.oxid != " . $oDb->quote($sVoucherId) . " and ";
                }
            }
            $sQ .= "( {$sViewName}.oxorderid is NULL || {$sViewName}.oxorderid = '' ) ";
            $sQ .= " and ( {$sViewName}.oxdateused is NULL || {$sViewName}.oxdateused = 0 ) ";
            //voucher timeout for 3 hours
            if ($blCheckavalability) {
                $iTime = time() - $this->_getVoucherTimeout();
                $sQ .= " and {$sViewName}.oxreserved < '{$iTime}' ";
            }
            $sQ .= " limit 1";
            $this->_odCreateNextVoucher($sVoucherNr);
            if (!($oRet = $this->assignRecord($sQ))) {
                $oEx = oxNew('oxVoucherException');
                $oEx->setMessage('ERROR_MESSAGE_VOUCHER_NOVOUCHER');
                $oEx->setVoucherNr($sVoucherNr);
                throw $oEx;
            }
        }
        return $oRet;
    }

    protected function _odCreateNextVoucher($sVoucherNr)
    {
        if ($sVoucherNr) {
            $sViewName = $this->getViewName();
            $sSeriesViewName = getViewName('oxvoucherseries');
            $oDb = oxDb::getDb();
            $rs = $oDb->execute("select {$sViewName}.oxvoucherserieid, {$sViewName}.oxorderid, {$sViewName}.oxdateused, {$sViewName}.oxreserved from {$sViewName} left join {$sSeriesViewName} on {$sSeriesViewName}.oxid = {$sViewName}.oxvoucherserieid where {$sViewName}.oxvouchernr = " . $oDb->quote($sVoucherNr) . " and {$sSeriesViewName}.odnewscoupon = 1");
            $aReturn = array();
            $id = null;
            if ($rs != false && $rs->recordCount() > 0) {
                $iTime = time() - $this->_getVoucherTimeout();
                while (!$rs->EOF) {
                    $id = $rs->fields[0];
                    if($rs->fields[3] < $iTime) {
                        $aReturn[] = $rs->fields[1];
                        $aReturn[] = $rs->fields[2];
                    }
                    $rs->moveNext();
                }
            }
            if (!in_array(NULL, $aReturn) && $id) {
                $oNewVoucher = oxNew("oxvoucher");
                $oNewVoucher->oxvouchers__oxvoucherserieid = new oxField($id);
                $oNewVoucher->oxvouchers__oxvouchernr = new oxField($sVoucherNr);
                $oNewVoucher->save();
            }
        }
    }
}